// place files you want to import through the `$lib` alias in this folder.

import { createTwitchClient } from "./twitch";

type WLEDAPI = {
    seg: Array<{ id: string; col: Array<[number, number, number]> }>;
};

const getAddr = (addr: string) => `http://${addr}/json/state`;

const buildReq = (hex: string): WLEDAPI => {
    // hex is not validated.

    const hexValues = parseInt(hex.slice(1), 16);

    const r = (hexValues >> 16) & 255;
    const g = (hexValues >> 8) & 255;
    const b = hexValues & 255;

    return {
        seg: [
            {
                id: "0",
                col: [[r, g, b]],
            },
        ],
    };
};

export const createLedClient = (addr: string) => {
    return {
        async setColor(hex: string) {
            await fetch(getAddr(addr), {
                method: "POST",
                body: JSON.stringify(buildReq(hex)),
            });
        },
    };
};

// export const twitchClient = createTwitchClient();
// twitchClient.subscribeToFollow();
